#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Mar  7 15:46:24 2018

@author: Salim
"""

from sklearn.datasets import load_boston

boston = load_boston()

print("Data shape: {}".format(boston.data.shape))

from sklearn.preprocessing import MinMaxScaler, PolynomialFeatures

def load_extended_boston():
    boston = load_boston()
    X = boston.data

    X = MinMaxScaler().fit_transform(boston.data)
    X = PolynomialFeatures(degree=2, include_bias=False).fit_transform(X)
    return X, boston.target

X, y = load_extended_boston()

print("X.shape: {}".format(X.shape))

