#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Mar 30 15:49:41 2018

@author: Salim
"""

class Point(object):
    "Définition d'un point géométrique"
    
p9 = Point()
print(p9)
print(p9.__doc__)

p9.x = 3.0
p9.y= 4.0

print(p9.x)
print(p9.x**2+p9.y**2)

x = p9.x

def affiche_point(p):
    print("Abscisse = ", p.x, "Ordonnée = ", p.y)
    
affiche_point(p9)

p1 = Point()
p1.x = 3
p1.y = 4

p2 = Point()
p2.x = 3
p2.y = 4

print(p1 == p2)

print(p1)

print(p2)

p2 = p1
print(p1 == p2)

p1.x = 7
print(p2.x)

print(p1)

print(p2)

class Rectangle(object):
    "définition d'une classe de rectangles"

boite = Rectangle()
boite.largeur = 50.0
boite.hauteur = 35.0
boite.coin = Point()
boite.coin.x = 12.0
boite.coin.y = 27.0

def trouveCentre(box):
    p = Point()
    p.x = box.coin.x+box.largeur/2.0
    p.y = box.coin.y+box.hauteur/2.0
    return p

centre = trouveCentre(boite)
print(centre.x, centre.y)

boite.hauteur = boite.hauteur + 20
boite.largeur = boite.largeur - 5

class Time(object):
    "Définition d'objets temporels"
    
    
instant = Time()
instant.heure = 11
instant.minute = 34
instant.seconde = 25

def affiche_heure(t):
    print(str(t.heure)+":"+str(t.minute)+":"+str(t.seconde))
    
affiche_heure(instant)

class Time(object):
    "Nouvelle classe temporelle"
    def affiche_heure(self):
        print("{0}:{1}:{2}".format(self.heure,self.minute,self.seconde))
        

maintenant = Time()
maintenant.heure = 23
maintenant.minute = 34
maintenant.seconde = 21

maintenant.affiche_heure()


class Time(object):
    "Encore une nouvelle classe temporelle"
    def __init__(self, hh = 12, mm = 0, ss = 0):
        self.heure = hh
        self.minute = mm
        self.seconde = ss
    def affiche_heure(self):
        print("{0}:{1}:{2}".format(self.heure,self.minute,self.seconde))

tstart = Time()
tstart.affiche_heure()

recreation = Time(10,15,18)
recreation.affiche_heure()

rentree = Time(10,30)
rentree.affiche_heure()

rdv = Time(hh = 18)
rdv.affiche_heure()

class Espaces(object):
    aa = 33
    def affiche(self):
        print(aa, Espaces.aa, self.aa)
        
aa = 12
essai = Espaces()
essai.aa = 67
essai.affiche()
print(aa, Espaces.aa, essai.aa)

class Mammifere(object):
    caract1 = "il allaite ses petits ;"

class Carnivore(Mammifere):
    caract2 = "il se nourrit de la chair de ses proies ;"
    
class Chien(Carnivore):
    caract3 = "son cri s'appelle aboiement ;"
    
mirza = Chien()
print(mirza.caract1,mirza.caract2,mirza.caract3)

mirza.caract2 = "son corps est couvert de poils ;"
print(mirza.caract2)

fido = Chien()
print(fido.caract2)

class Atome:
    """Atomes simplifiés choisis parmi les 10 premiers éléments du TPE"""
    table = [None, ('hydrogène',0), ('hélium',2), ('lithium',4), ('béryllium',5),
             ('bore',6), ('carbone',6), ('azote',7), ('oxygène',8), ('fluor',10),
             ('néon',10)]
    
    def __init__(self, nat):
        "le n° atomique détermine le nombre de protons, d'électrons et de neutrons"
        self.np, self.ne = nat, nat
        self.nn = Atome.table[nat][1]
        
    def affiche(self):
        print()
        print("Nom de l'élément : ", Atome.table[self.np][0])
        print("{0} protons, {1} électrons, {2} neutrons".format(self.np,self.ne,self.nn))
        
class Ion(Atome):
    """Les ion ssont des atomes qui ont perdu ou gagné des électrons"""
    
    def __init__(self, nat, charge):
        "le n° atomique et le charge électrique déterminent l'ion"
        Atome.__init__(self,nat)
        self.ne = self.ne - charge
        self.charge = charge
    
    def affiche(self):
        Atome.affiche(self)
        print("Particule électrisée. Charge = ", self.charge)
        
a1 = Atome(5)
a2 = Ion(3,1)
a3 = Ion(8,-2)
a1.affiche()
a2.affiche()
a3.affiche()












