#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Jan 15 11:07:18 2018

@author: 
    
A. Casamayou-Boucau & al.
"Programmation en Python pour les Mathématiques" 2ème édition
Dunod 2016

modifié par Salim Lardjane, Université de Bretagne Sud
"""

from numpy import random

def monty(n):
    gagne_sans_changer = 0
    gagne_en_changeant = 0
    for j in range(n):
        voiture = random.randint(0,3)
        choix = random.randint(0,3)
        if choix == voiture:
            ouverte = (voiture+1+random.randint(0,2)) % 3
        else:
            ouverte = 0 + 1 + 2 - choix - voiture
        changement = 0 + 1 + 2 - choix - ouverte
        if choix == voiture:
            gagne_sans_changer += 1
        if changement == voiture:
            gagne_en_changeant += 1
    return 'Gagne en changeant : '+str(100.*gagne_en_changeant/n)+'%  Gagne sans changer : '+str(100.*gagne_sans_changer/n)+'%'

monty(50000)