#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Mar  7 15:45:20 2018

@author: Salim
"""

from sklearn.datasets import load_breast_cancer
import numpy as np

cancer = load_breast_cancer()

print("cancer.keys(): \n{}".format(cancer.keys()))

print("Shape of cancer data : {}".format(cancer.data.shape))

print("Sample count per class:\n{}".format(
        {n: v for n, v in zip(cancer.target_names,np.bincount(cancer.target))}))

print("Feature names: \n{}".format(cancer.feature_names))