#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Wed Nov 22 17:11:40 2017

@author: Salim
"""

import pandas as pd
import matplotlib.pyplot as plt
data = pd.DataFrame({
'Gender' : ['f', 'f', 'm', 'f', 'm',
                   'm', 'f', 'm', 'f', 'm', 'm'],
'TV' : [3.4, 3.5, 2.6, 4.7, 4.1, 4.1,
          5.1, 3.9, 3.7, 2.1, 4.3]
})

# Regroupement des données
grouped = data.groupby('Gender')
# Statistiques de base
print(grouped.describe( ))
# Représentations graphiques
grouped.boxplot( )
plt.show( )

import numpy as np
import pandas as pd
import statsmodels.formula.api as sm
x = np.arange(100)
y = 0.5*x-20+np.random.randn(len(x))
df = pd.DataFrame({'x':x, 'y':y})
model = sm.ols('y~x', data=df).fit( )
print(model.summary( ))

import numpy as np
import matplotlib.pyplot as plu
import pandas as pd
import seaborn as sns 
x = np.linspace(1,7,50)
y = 3+2*x+1.5*np.random.randn(len(x))
df = pd.DataFrame({'xData':x, 'yData':y})
sns.regplot('xData', 'yData', data = df)
plt.show( )
