#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Mon Nov 20 12:57:43 2017

@author: Salim
"""

import numpy as np
import pylab as pl


N = 500

app = np.where(np.random.normal(size=N) <= 0.5,1,0)


def err(x,k):
   n = len(x)
   nb_err = 0
   for i in range(k+1,n,1): 
       hist = x[(i-k):(i-1)]
       if (np.sum(hist) >= k/2): 
           prev = 1 
       else: 
           prev = 0
       if (prev != x[i]): 
           nb_err = nb_err+1
   return(nb_err/(n-k))

res = []
for k in range(0,20,1): 
   res.append(err(app,k+1))

pl.plot(np.arange(1,21,1),res)
pl.xticks(np.arange(1, 21, 1))
pl.xlabel('N')
pl.ylabel('Erreur')
pl.show()

np.argmin(res)+1