#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Nov 17 12:22:39 2017

@author: Salim
"""

from scipy.stats import norm
import numpy as np
import matplotlib.mlab as mlab
import pylab as pl
import math


def simul():
  n = 30
  N = int(input("Nombre d'échantillons:"))
  x = np.random.rand(N,n)
  m = np.mean(x,axis=1)
  z = (m-0.5)/(math.sqrt(1/(12*n)))

  n, bins, patches = pl.hist(z, 10*math.floor(math.log(N)), normed=1, facecolor='green', alpha=0.75)
  y = mlab.normpdf( bins, 0, 1)
  l = pl.plot(bins, y, 'r--', linewidth=2)

  pl.xlabel('z')
  pl.ylabel('Probability')
  pl.grid(True)

  pl.show()

simul()