#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Nov 24 17:57:38 2017

@author: Salim
"""

####################################
# Dessin avec Turtle sous Python   #
####################################

#Bibliographie :

#Informatique avec Python - Serge Bays - Ellipses  2017


# Exemple

from turtle import *

forward(120)
left(120)
color('red')
forward(80)

reset()

up()
goto(-200,50)
down()
speed("fast")
circle(40)
speed("slowest")
circle(80,270)
speed("normal")
circle(50)

reset()

width(2)
hideturtle()
color('green')
begin_fill()
for a in range(4):
    forward(50)
    left(90)
end_fill()

reset()

color('purple')
a = 0
while (a < 12):
    a+=1
    forward(150)
    left(150)

reset()

up()
goto(100,-80)
down()
color('blue')
write('bonjour')

# Ecrire à l’aide du module turtle un programme récursif qui trace la courbe 
# de von Koch à différents niveaux

from turtle import *

def courbe(longueur,niveau):
    if niveau == 1:
        forward(longueur)
    else:
        courbe(longueur/3,niveau-1)
        left(60)
        courbe(longueur/3,niveau-1)
        right(120)
        courbe(longueur/3,niveau-1)
        left(60)
        courbe(longueur/3,niveau-1)

up()
goto(-300,0)
down()
speed("normal")
courbe(600,5)
        

# On obtient un flocon de von Koch en accolant trois courbes de von Koch aux trois 
# sommets d’un triangle équilatéral. Ecrire à l’aide du module turtle un programme 
# récursif qui trace le flocon de von Koch.

def flocon(t,n):
    left(60)
    courbe(t,n)
    right(120)
    courbe(t,n)
    right(120)
    courbe(t,n)
    
up()
goto(-200,-100)
down()
speed("fastest")
flocon(400,5)

# Reprendre l’exercice précédent en testant divers angles autres que 60. Pour cela, 
# ajouter un troisième paramètre représentant l’angle aux fonctions traçant la courbe et 
# le flocon. Attention, il faut modifier le code de la fonction traçant la courbe de 
# façon à ce que la longueur de la figure reste la même à chaque niveau.

from tkinter import *
from turtle import *

from math import pi, cos

def courbe(longueur,niveau,alpha):
    if niveau == 1:
        forward(longueur)
    else:
        rapport = 2+2*cos(pi*alpha/180)
        courbe(longueur/rapport,niveau-1,alpha)
        left(alpha)
        courbe(longueur/rapport,niveau-1,alpha)
        right(2*alpha)
        courbe(longueur/rapport,niveau-1,alpha)
        left(alpha)
        courbe(longueur/rapport,niveau-1,alpha)
        
def flocon(t,n,a):
    left(60)
    courbe(t,n,a)
    right(120)
    courbe(t,n,a)
    right(120)
    courbe(t,n,a)
    
up()
goto(-200,-100)
down()
speed("fastest")
flocon(400,5,80)
hideturtle()

# Sauvegarde de la figure au format Postscript

ts = getscreen()
ts.getcanvas().postscript(file = "/Users/Salim/Desktop/vonkoch.eps")

done() # arrête la session turtle

